<template lang="pug">
div
  .row
    .col
      .text-overline Reports move through the following stages: 
      q-badge(color="warning") draft
      q-icon(name="east")
      q-badge(color="grey") submitted
      q-icon(name="east")
      q-badge(color="grey") transcoded
      q-icon(name="east")
      q-badge(color="info") readyformoderation
      q-icon(name="east")
      q-badge(color="grey") moderated
      q-icon(name="east")
      q-badge(color="positive") edited
      span.q-mx-sm.text-overline OR
      q-badge(color="red") error
  .row 
    .col
      //- div {{pagination}}
      q-table.no-shadow.no-border(
        :rows-per-page-options="[10,20,50,100,200]"
        :data="submissions",
        :columns="submissionColumn",
        :loading="loading",
        row-key="submitted_by",
        :pagination.sync="pagination",
        @request="onRequest"
      )
        template(v-slot:body="props")
          q-tr(:props="props")              
            q-td(auto-width)
              q-btn(size="sm" color="accent" round dense @click="props.expand = !props.expand" :icon="props.expand ? 'remove' : 'add'")
            q-td(auto-width)
              span {{ props.row.submitted_by.displayName }}
            q-td(auto-width)
              span {{ props.row.submitted_by.email }}
            q-td(auto-width) {{ (props.row.lastTouched)?getTime(props.row.lastTouched):''}}
            q-td(auto-width) {{ codeToFlag(props.row.region) }}
              q-tooltip {{ codeToName(props.row.region) }}
            q-td(auto-width) {{ codeToLang(props.row.language) }} ({{ codeToLang(props.row.commslanguage) }})
            q-td(auto-width)
              span(:class="[`text-${getChipColor(sub.status)}`]"  :key="sub.id",v-for="sub in props.row.submissions" style="font-size:60px;line-height:28px;") &middot;
            
            //- q-td(auto-width)
            //-   q-btn(icon="flag", flat, round, dense, disabled)
          q-tr(v-show="props.expand" :props="props")
            q-td(colspan="100%" style="max-width:100%;")
              .row.q-col-gutter-xs
                .col-auto(:key="sub.id",v-for="sub in props.row.submissions",)
                  //- div {{getThumbnail(sub.media)}}
                  q-card(flat bordered :class="[`bg-${getChipColor(sub.status)}`]" )
                    .absolute-top-left.z-top
                      q-badge(color="grey-8") {{ sub.status }} {{sub.error}}
                    .row
                      
                      q-img.bg-grey-1(:src="getThumbnail(sub)" :ratio="16/9" style="width:100%;min-width:220px;")
                        template(v-slot:error)
                          q-icon(name="image" color="grey" size="xl").absolute-center

                    .column.q-pa-xs
                      .text-small {{getTime(sub.createdAt)}} &middot; {{ $t(`phase.phase_${sub.phase}`) }}
                      .text-small()
                        span(v-if="sub.moderatedBy") Moderated by {{ sub.moderatedBy.displayName }}, {{ getTime(sub.moderatedAt) }}
                        span(v-if="!sub.moderatedBy") ...
                        //- span {{sub.id}}
                      q-tooltip {{ sub.id }}
</template>

<script>
import { adminListSubmissions, db } from "@/db";
import { DateTime } from "luxon";
import regions from "@/ifrclist.json";
import langmap from "langmap";
import { mapState, mapActions } from "vuex";
import { find, map, filter, includes } from "lodash";

export default {
  components: {},
  computed: {
    phaseoptions() {
      if (!this.config.phases) return [];
      return map(filter(this.config.phases, "visible"), (m) => {
        return {
          value: m.code,
          label: this.$t("phase.phase_" + m.code),
        };
      });
    },
    ...mapState({
      user: (state) => state.user,
      judging: (state) => state.judging,
    }),
  },
  data: () => {
    return {
      pagination: {
        sortBy: "submitted_by.user_name",
        descending: true,
        page: 1,
        rowsPerPage: 50,
        rowsNumber: -1,
        judgeStarted: false,
      },
      config: {
        current_phase: -1,
      },
      loading: false,
      lastone: {},
      submissions: [],
      terms: {},
      submissionColumn: [
        {
          label: "",
          name: "linkedin",
          field: "linkedin",
          align: "left",
          sortable: false,
        },
        {
          label: "Contributor",
          name: "submitted_by.user_name",
          field: "submitted_by.user_name",
          align: "left",
          sortable: true,
        },
        {
          label: "Email",
          name: "submitted_by.email",
          field: "submitted_by.email",
          align: "left",
          sortable: false,
        },
        {
          label: "Last Touched",
          name: "lastTouched",
          align: "left",
          field: "lastTouched",
          sortable: true,

          // format: (val) => `${DateTime.fromSeconds(val._seconds).toRelative()}`,
        },
        {
          label: "NS",
          name: "region",
          field: "region",
          align: "left",
          sortable: false,
        },
        {
          label: "Language (Comms)",
          name: "language",
          field: "language",
          align: "left",
          sortable: true,
        },
        {
          name: "Submissions",
          label: "Reports",
          field: "submissions",
          sortable: false,
          align: "left",
        },

        // {
        //   name: "Actions",
        //   label: "Actions",
        //   sortable: false,
        //   align: "right",
        // },
      ],
    };
  },
  watch: {
    terms: {
      deep: true,
      // immediate:true,
      async handler() {},
    },
  },
  mounted() {
    this.onRequest({
      pagination: this.pagination,
    });
  },
  methods: {
    // format: (val) => {
    //         if (!val) return "-";
    //         else return `${DateTime.fromSeconds(val._seconds).toRelative()}`;
    //       },
    // getS3Link(src) {
    //   if (!src) return "";
    //   return `${this.config.cloudfronturl}${src
    //     .replace("s3://", "")
    //     .replace(this.config.bucketname, "")}`;
    // },
    getThumbnail(submission) {
      return `${this.config.cloudfronturl}/submissions/${submission.id}/${submission.media}/${submission.media}_transcoded.0000001.jpg`;
    },
    getTime(t) {
      // console.log(t);
      return `${DateTime.fromSeconds(t._seconds).toRelative()}`;
    },
    ...mapActions(["startJudging"]),
    async startJudgingProgress() {
      this.$q.loading.show({
        message: this.$t("waiting_judging"),
      });
      const error = await this.startJudging();
      this.$q.loading.hide();
      if (!error) {
        this.judgeStarted = true;
        this.$q.notify({
          type: "positive",
          message: this.$t("judging_success"),
        });
      } else
        this.$q.notify({
          type: "negative",
          message: this.$t("judging_error"),
        });
    },
    async savePhase() {
      try {
        await db
          .collection("config")
          .doc("meta")
          .update({
            current_phase: this.config.current_phase,
          });
      } catch (e) {
        this.showError(e);
      }
    },
    codeToName(val) {
      // console.log(val);
      if (!val) return "-";
      let f = find(regions, { code: val });
      if (!f) return val;
      return `${f.flag} ${f.name}`;
    },
    codeToFlag(val) {
      // console.log(val);
      if (!val) return "-";
      let f = find(regions, { code: val });
      if (!f) return val;
      return `${f.flag}`;
    },
    codeToLang(val) {
      if (!val) return "-";
      let l = langmap[val.toLowerCase()];
      return l ? l.englishName : val;
    },
    async onRequest(props) {
      this.loading = true;
      let tmp = (await adminListSubmissions(props)).data;

      if (this.pagination.rowsNumber == -1)
        this.pagination.rowsNumber = tmp.meta.total;

      this.pagination.page = tmp.meta.page;
      this.pagination.sortBy = tmp.meta.sortBy;
      this.pagination.descending = tmp.meta.descending;
      // console.log(tmp.meta);
      this.pagination.rowsPerPage = tmp.meta.pagesize;

      this.submissions = tmp.data;
      this.loading = false;
    },
    getChipColor(status) {
      if (status === "submitted") {
        return "warning";
      } else if (status === "readyformoderation") {
        return "info";
      } else if (status === "moderated") {
        return "grey";
      } else if (status === "rejected" || status == "error") {
        return "negative";
      } else if (
        status === "translated" ||
        status === "subtitled" ||
        status == "draft"
      ) {
        return "warning";
      } else if (status === "finalised" || status == "edited") {
        return "positive";
      } else {
        return "grey";
      }
    },
    judgingStart() {
      if (!this.user) return false;
      return (
        includes(this.user.roles, "superadmin") &&
        this.judging &&
        !this.judgeStarted
      );
    },
  },
  firestore: {
    config: db.collection("config").doc("meta"),
  },
};
</script>

<style lang="scss" scoped>
.text-small {
  font-size: 0.8em;
}
</style>
